# KubernetesClusterProperties

## Properties

\| **api\_subnet\_allow\_list** | **Array\<String>** | Access to the K8s API server is restricted to these CIDRs. Traffic, internal to the cluster, is not affected by this restriction. If no allowlist is specified, access is not restricted. If an IP without subnet mask is provided, the default value is used: 32 for IPv4 and 128 for IPv6. | \[optional] |

\| **available\_upgrade\_versions** | **Array\<String>** | List of available versions for upgrading the cluster | \[optional] |

\| **k8s\_version** | **String** | The Kubernetes version the cluster is running. This imposes restrictions on what Kubernetes versions can be run in a cluster's nodepools. Additionally, not all Kubernetes versions are viable upgrade targets for all prior versions. | \[optional] |

\| **maintenance\_window** | [**KubernetesMaintenanceWindow**](/ruby-sdk/models/kubernetesmaintenancewindow.md) | | \[optional] |

\| **name** | **String** | A Kubernetes cluster name. Valid Kubernetes cluster name must be 63 characters or less and must be empty or begin and end with an alphanumeric character (\[a-z0-9A-Z]) with dashes (-), underscores (\_), dots (.), and alphanumerics between. | |

\| **s3\_buckets** | [**Array\<S3Bucket>**](/ruby-sdk/models/s3bucket.md) | List of S3 bucket configured for K8s usage. For now it contains only an S3 bucket used to store K8s API audit logs | \[optional] |

\| **viable\_node\_pool\_versions** | **Array\<String>** | List of versions that may be used for node pools under this cluster | \[optional] |

## Example

```ruby
require 'ionoscloud'


instance = Ionoscloud::KubernetesClusterProperties.new(
  api_subnet_allow_list: [1.2.3.4/32, 2002::1234:abcd:ffff:c0a8:101/64, 1.2.3.4, 2002::1234:abcd:ffff:c0a8:101],

  available_upgrade_versions: [1.16.4, 1.17.7],

  k8s_version: 1.15.4,

  maintenance_window: null,

  name: k8s,

  s3_buckets: null,

  viable_node_pool_versions: [1.17.7, 1.18.2]
)
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.ionos.com/ruby-sdk/models/kubernetesclusterproperties.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
